/*
 * main.cpp
 *
 *  Created on: 20/08/2009
 *      Author: Virginia Silva da Costa
 */
#include <cassert>
#include <iostream>
#include <string>
#include "CoinError.hpp"
//#include "OsiCuts.hpp"
//#include "OsiClpSolverInterface.hpp"
#include "OsiSymSolverInterface.hpp"

//#include "CglGomory.hpp"

using std::cerr;
using std::cout;
using std::endl;
using std::string;

int main (void)
{

		char	tspfilename[80] = "gr177.tsp";
		int		dimension;
		char	edge_weight_type[80];
		char	edge_weight_format[80];

		CoinPackedVector row;
		CoinPackedMatrix *Matrix;
		OsiSolverInterface *si;
		si = new OsiSymSolverInterface;


		double 		*wij, *collb, *colub, *rowlb, *rowub;



		string		strbuffer;
		FILE 		* pFile = fopen (tspfilename,"r");
		char 		type[80];
		char 		str[80];

		int			i,j,k;
		int 		*ei, *ej, *yi, *yj;

		while(!feof(pFile))
		{	  // Verificando se o arquivo é tipo tsp
			fscanf (pFile, "%s", str);
			strbuffer = str;
			if (strbuffer.compare("TYPE:") == 0)
			{
				fscanf (pFile, "%s\n", type);
				strbuffer = type;
				if(strbuffer.compare("TSP")!=0)
				{
					cout << "Sorry, but It isn't a TSP file. Please, try again."<< endl;
					return 1;
				}
				else
				{
					break;
				}
			}
		}
		rewind(pFile);

		while(!feof(pFile))
		{	  // Procurando dimensão
			fscanf (pFile, "%s", str);
			strbuffer = str;
			if (strbuffer.compare("DIMENSION:") == 0)
			{
				fscanf (pFile, "%d\n", &dimension);
				break;
			}
		}
		rewind(pFile);

		while(!feof(pFile))
		{	  // Procurando tipo de peso
			fscanf (pFile, "%s", str);
			strbuffer = str;
			if (strbuffer.compare("EDGE_WEIGHT_TYPE:") == 0)
			{
				fscanf (pFile, "%s\n", edge_weight_type);
				break;
			}
		}
		rewind(pFile);

		while(!feof(pFile))
		{	  // Procurando tipo de peso
			fscanf (pFile, "%s", str);
			strbuffer = str;
			if (strbuffer.compare("EDGE_WEIGHT_FORMAT:") == 0)
			{
				fscanf (pFile, "%s\n", edge_weight_format);
				break;
			}
		}
		rewind(pFile);


		strbuffer = edge_weight_type;
		int 	nnz = 0;
		int 	cont = 0;
	    int 	e_size = 0;

		int 	n_cols = 0;
		int 	n_rows = 0;


		if (strbuffer.compare("EXPLICIT") == 0)
		{
			strbuffer = edge_weight_format;

			if (strbuffer.compare("LOWER_DIAG_ROW") == 0)
			{
				double aux;
				nnz = dimension*(1+dimension)/2 - dimension;
				e_size = 2*nnz;// - dimension;

				//cout << "nnz = " << nnz << endl;
				wij = new double[nnz];

				yi  = new int[nnz];
				yj  = new int[nnz];

				ei = new int[e_size];
				ej = new int[e_size];

				n_cols = nnz*(2*dimension - 1);//nnz*(4*dimension - 3);
				n_rows = dimension*dimension + e_size*(dimension - 1);

			//	n_cols = 2*nnz*dimension + nnz - e_size;
			//	n_rows = (4*nnz*dimension +dimension*dimension - nnz) -2*nnz*dimension -nnz;

				Matrix =  new CoinPackedMatrix(false,0,0);
				Matrix->setDimensions(0, n_cols);

				while(!feof(pFile))
				{	  // lendo pesos
					fscanf (pFile, "%s", str);
					strbuffer = str;
					if (strbuffer.compare("EDGE_WEIGHT_SECTION") == 0)
					{
					//	for (i = 0 ; i < nnz + dimension ; i++) fscanf (pFile, "%le", &v[i]); // para ler diagonal

						for (i = 0 ; i < n_cols ; i++ ) wij[i] = 0.;

						cont = 0;
						for (i = 0 ; i < dimension ; i++)
						{
							for (j = 0 ; j < i+1 ; j++)
							{
								if(i!=j)
								{
									fscanf (pFile, "%le", &wij[cont]);
									cont++;
								}
								else
								{
									fscanf (pFile, "%le", &aux);
								}
							}
						}
					}
				}

				// Ajustando arestas {i,j}
				cont = 0;
				for(i = 0 ; i < dimension; i++ )
				{
					for(j = 0 ; j < i+1; j++)
					{
						if (i!=j){
							yi[cont] = i;
							yj[cont] = j;
							cont++;
						}
					}
				}

				// Ajustando arestas (i,j) (j,i)
				for (i = 0 ; i < nnz ; i++)
				{
					ei[i] = yi[i];
					ej[i] = yj[i];
					ei[nnz + i] = yj[i];
					ej[nnz + i] = yi[i];
				}

				// Matrix
				for (i = 0 ; i < dimension ; i++)
				{
					for (j = 0 ; j< nnz ; j++)
					{
						if((yi[j] == i)||(yj[j]== i))
						{
							row.insert(j,1.);
						}
					}
					cout << "n_cols = "<<n_cols<<endl;
					cout << "n_rows = " << n_rows<<endl;

					cout << "aqui"<<endl;
					Matrix->appendRow(row);
					row.clear();
				}


				cont = nnz;
				for (k = 1 ; k < dimension ; k++)
				{
					for (i = 0 ; i < dimension ; i++)
					{
						for (j = 0 ; j < e_size ; j++)
						{
							if (ei[j] == i)
							{
								row.insert(cont + j,1.);
							}
							if (ej[j] == i)
							{
								row.insert(cont + j, -1.);
							}
						}
						cout << row.getNumElements()<<endl;
						Matrix->appendRow(row);   //O ERRO ESTÀ AQUI!!!!!!
						row.clear();
					}
					cont+=e_size;
				}

				cont = nnz;

				for (i = 0 ; i < 2*(dimension - 1) ; i++)
				{
					for (j = 0 ; j < nnz ; j++)
					{
						row.insert(j,-1.);
						row.insert(cont+j,1.);
						Matrix->appendRow(row);
						row.clear();
					}
					cont += nnz;
				}
				// RHS
				rowub = new double[n_rows];

				for (i = 0 ; i < n_rows ; i++ ) rowub[i] = 0.;


				for (i = 0 ; i < dimension; i++) rowub[i] = 2.;

				cont = dimension;

				for (i = 1 ; i < dimension; i++)
				{
					for (j = 0 ; j < dimension; j++)
					{
						if ( j == 0)
						{
							rowub[cont + j] = 1.;
						}
						else
						{
							if (j == i)
							{
								rowub[cont + j] = -1.;
							}
							else
							{
								rowub[cont + j] = 0.;
							}
						}
					}
					cont += dimension;
				}
				rowlb = new double[n_rows];

				for (i = 0 ; i < n_rows ; i++ ) rowlb[i] = rowub[i];

				for (i = dimension*dimension ; i < n_rows ; i++)
				{
					rowlb[i] = -1.0*si->getInfinity();
				}

				collb = new double[n_cols];

				for (i = 0 ; i < n_cols ; i++) collb[i] = 0.;

				colub = new double[n_cols];

				for (i = 0 ; i < dimension ; i++) colub[i] = 1.;

				for (i = dimension ; i < n_cols ; i++ ) colub[i] = si->getInfinity();

				si->loadProblem(*Matrix,collb,colub,wij,rowlb,rowub);

				for(i = 0 ; i < nnz; i++) si->setInteger(i);

				cout << "++++++++++++++++++++++++++++++++++++++++++++++++++"<<endl;
				cout << "TspFile Object Information: "<< endl;
				cout << "--------------------------------------------------"<<endl;
				cout << "\tdimension = " << dimension << endl;
				cout << "\tedge_weight_type = " << edge_weight_type << endl;
				cout << "\tedge_weight_format = " << edge_weight_format << endl;
				cout << "\tThere's "<< nnz << " nonzero elements."<<endl;
				cout << "\tNumber of Rows = "<<n_rows << "\tsi = "<< si->getNumRows()<< "\tMatrix = "<<Matrix->getNumRows() << endl;
				cout << "\tNumber of Columns = "<<n_cols <<"\tsi = "<<si->getNumCols() <<"\tMatrix = "<<Matrix->getNumCols() << endl;
				cout << "++++++++++++++++++++++++++++++++++++++++++++++++++"<<endl << endl;

				for ( i = 0 ; i < nnz; i++ ) cout << "i = " <<i << "\tyi = " << yi[i] <<"\tyj = "<< yj[i]<<"\twij = "<<wij[i] <<endl;
				cout << endl;
				for ( i = 0 ; i < e_size; i++ ) cout << "i = " <<i << "\tei = " << ei[i] <<"\tej = "<< ej[i] <<endl;
				cout << endl;

				for ( i = 0 ; i < Matrix->getNumRows(); i++ )
				{
					for (j = 0 ; j < Matrix->getNumCols();j++)
					{
					 cout<< Matrix->getCoefficient(i,j)<<"\t";
					}
					cout<<endl;
				}
				cout << endl;

				for (i = 0 ; i < n_rows ; i++ ) cout << "rowub[" << i << "] =\t" << rowub[i] << endl;
				cout << endl;
				for (i = 0 ; i < n_rows ; i++ ) cout << "rowlb[" << i << "] =\t" << rowlb[i] << endl;
				cout << endl;

				for (i = 0 ; i < n_cols ; i++ ) cout << "colub[" << i << "] =\t" << colub[i] << endl;
				cout << endl;
				for (i = 0 ; i < n_cols ; i++ ) cout << "collb[" << i << "] =\t" << collb[i] << endl;


				si->writeMps("tspsi");

				// Resolvendo o problema (relaxação)
				si->initialSolve();

			   // Verificando a solucao
			   if ( si->isProvenOptimal() ) {
			      cout << "Solucao otima encontrada!" << endl;
			      cout << "O valor da funcao objetivo e " << si->getObjValue() << endl;
			      int n = si->getNumCols();
			      const double *solution;
			      solution = si->getColSolution();
			   } else {
			      cout << "Solucao otima nao encontrada." << endl;
			   }

			}
		}
		if (strbuffer.compare("EUC_2D") == 0)
		{
			cout << "Not ready yet!" << endl;
		}
		if (strbuffer.compare("EUC_3D") == 0)
		{
			cout << "Not ready yet!" << endl;
		}
		fclose(pFile);
		delete [] ei;
		delete [] ej;
		delete [] yi;
		delete [] yj;
		delete [] wij;
		delete [] collb;
		delete [] colub;
		delete [] rowlb;
		delete [] rowub;
		delete Matrix;
		delete si;
	return 0;
}
